/*

Change log:
	03-11-04 14:02 v0.1a
			1. initial build.
			2. stl::vector -> simple DLL ( maybe buggy )
	05-11-04 07:30 v0.1b
			1. abort Dev-Cpp prj, move to vcpp6.
			2. fix some bugs.
	05-11-04 17:19 v0.1c
			1. incomplete or bad archive : handle as bad data. 
 	08-11-04 02:35 v0.1d
			1. more detailed unpacking status. ( UnAlzCallback )
			2. added public member function : CUnAlz::IsHalted();      
			silent update:
                1. Bloodshed Dev-Cpp Returns : much bigger output, but works fine.
    09-11-04 19:25 v0.1e
            1. more detailed file listing.
            2. out files now has original file time. ( !directory )
			silent update:
				1. function overload : void	CUnAlz::SetCurrentFile(struct FNode* curFile);
				2. so speedup.
	12-11-04 11:12 v0.1f - internal 
			1. Added Encrypted Archive Support.
			2. And I'm in Hell of Win32 API. I made dialogbox with resource editor in VCPP6, but i don't know how to use it. :-< 
	14-11-04 07:27 v0.1g
            1. Added dialogbox for password input.
            2. Encrypted bzip2/inflate/raw support.
	19-11-04 01:57 v0.1h
            1. incomplete or bad archive : trying to proceed. (EXPERIMENTAL)
            2. password dialog : ESC key now works.
			silent update: 
				1. some code cleanup.
				2. dialogbox now pops on its right position.
	24-11-04 05:44 v0.1i
            1. basecode changed : unalz v0.30, zlib v1.2.1
            2. weird error code by CUnAlz::ExtractCurrentFile() fixed.
            3. NULL pointer Acess violation error fixed.
            4. some code cleanup.
                        
Plugin		by mario	(xxfree86@shinbiro.com)
unalz v0.30 by hardkoder(hardkoder@gmail.com / http://www.kipple.pe.kr)


*/
#include <windows.h>
#include <stdlib.h>
#include "wcxhead.h"
#include "UnAlz.h"
#include "unalzx.h"
#include "utilz.h"
#include "inputbox.h"

HINSTANCE g_hInst;
char passwd[256];



extern "C" BOOL APIENTRY DllMain (HINSTANCE hInst     /* Library instance handle. */ ,
                       DWORD reason        /* Reason this function is being called. */ ,
                       LPVOID reserved     /* Not used. */ )
{
    switch (reason)
    {
      case DLL_PROCESS_ATTACH:
		g_hInst = hInst;
        break;

      case DLL_PROCESS_DETACH:
        break;

      case DLL_THREAD_ATTACH:
        break;

      case DLL_THREAD_DETACH:
        break;
    }
	
    /* Returns TRUE on success, FALSE on failure */
    return TRUE;
}

 

static void UnAlzCallback (const char* szMessage, INT64 nCurrent, INT64 nRange, void* param, BOOL* bHalt)
{
	t_AlzData *archivinfo=(t_AlzData *)param;

    if (archivinfo->ProcessDataProc){
        if (archivinfo->ProcessDataProc((char *)szMessage, nCurrent - archivinfo->curLen)==0){
			*bHalt = TRUE;
        }
		archivinfo->curLen = nCurrent;
    }

}

static int process_archive(t_AlzData *archivinfo, char *path, char *dest)
{
	int result;
	SLocalFileHeader* tmp;

    archivinfo->Data.SetCurrentFile(archivinfo->FileList);
    tmp = archivinfo->FileList->Data;

    if (archivinfo->Data.ExtractCurrentFile(dest) == TRUE){
		if(setFileTimeTo(dest, tmp->head.fileTimeDate)){
			;  //success.      
		} else {
			;  //failed.    
		}
		result = 0;
    } else {
		if(archivinfo->Data.GetLastErr() == archivinfo->Data.ERR_INVALID_PASSWD){
			myAlert(archivinfo->Data.GetLastErrStr());
			result = E_NOT_SUPPORTED;
		} else {
			result = E_EREAD;
		}
	}

	if (archivinfo->Data.IsHalted()){
		result = E_EREAD;
	}
	archivinfo->curLen = 0;
	return result;
}


DLLIMPORT(UNALZHANDLE)  OpenArchive (tOpenArchiveData *ArchiveData)
{
	BOOL result;
	t_AlzData *archivinfo = NULL;

	if (ArchiveData->OpenMode == PK_OM_LIST || ArchiveData->OpenMode == PK_OM_EXTRACT){

        archivinfo = new t_AlzData;
		 
		if (archivinfo == NULL){
			
			ArchiveData->OpenResult = E_NO_MEMORY;
			
			return NULL;
		}
		result = archivinfo->Data.Open(ArchiveData->ArcName);
		
		if (result){
			archivinfo->Data.SetCallback(UnAlzCallback, archivinfo);
			archivinfo->FileList = archivinfo->Data.GetFileList();
			return archivinfo;
		} else { 
				
			if ( (archivinfo->FileList = archivinfo->Data.GetFileList()) != NULL){
				if(ArchiveData->OpenMode == PK_OM_LIST)
					myAlert("Incomplete or Bad Archive.  \n\nBut Trying to Proceed...");
				archivinfo->Data.SetCallback(UnAlzCallback, archivinfo);
				return archivinfo;
			} else {
				delete archivinfo;   // open failed : bad archive?
				archivinfo = NULL;
				ArchiveData->OpenResult = E_NOT_SUPPORTED;
				return NULL;
			}
		}    
	} else {
		ArchiveData->OpenResult = E_NOT_SUPPORTED;
		return NULL;
	}
}

DLLIMPORT(int)   ReadHeader (UNALZHANDLE hArcData, tHeaderData *HeaderData)
{
	char *p;

	if (hArcData->FileList->next){
        strcpy(HeaderData->FileName, hArcData->FileList->Data->fileName);
        p = HeaderData->FileName;
      	while (*p!='\0'){
                if (*p=='/')*p='\\';
                p++;
        }

     	HeaderData->FileAttr = hArcData->FileList->Data->head.fileAttribute;
      	HeaderData->FileTime = hArcData->FileList->Data->head.fileTimeDate;
      	HeaderData->PackSize = hArcData->FileList->Data->compressedSize;
      	HeaderData->UnpSize  = hArcData->FileList->Data->uncompressedSize;

    	return 0;
    } else {
		hArcData->FileList = hArcData->Data.GetFileList();

        return E_END_ARCHIVE;
    }      

}

DLLIMPORT(int) ProcessFile (UNALZHANDLE hArcData, int Operation, char *DestPath, char *DestName)
{
	int result;
	int DlgRst;	
	if (Operation == PK_EXTRACT){
				
        if (hArcData->Data.IsEncrypted() && (hArcData->Data.getPasswordLen() == 0)) {
			DlgRst = DialogBox(g_hInst, MAKEINTRESOURCE(IDD_DIALOG1), GetForegroundWindow(), InfoDlgProc);
            if (DlgRst == IDOK){
				hArcData->Data.setPassword(passwd);
			} else {
				return E_EABORTED;
			}
		}
		result = process_archive(hArcData, DestPath, DestName);

		if (result == 0){ // weird errs're gone in zlib 1.2.1 
		    hArcData->FileList = hArcData->FileList->next;
			return result;
		} else {
			return result;   
  		}    
	} else if (Operation == PK_TEST || Operation == PK_SKIP){
	    hArcData->FileList = hArcData->FileList->next;
		return 0;
	} else
		return E_NOT_SUPPORTED;

}

DLLIMPORT(int)  CloseArchive (UNALZHANDLE hArcData)
{
    delete hArcData;
	hArcData = NULL;
    
    return 0;
}

DLLIMPORT(void) SetChangeVolProc (UNALZHANDLE hArcData, tChangeVolProc pChangeVolProc)
{
	hArcData->ChangeVolProc=pChangeVolProc;
}

DLLIMPORT(void) SetProcessDataProc (UNALZHANDLE hArcData, tProcessDataProc pProcessDataProc)
{
	hArcData->ProcessDataProc=pProcessDataProc;
}


static void	myAlert(const char * msg){
	MessageBoxEx(NULL, (char *)msg , "Alzip Sucks.", MB_ICONSTOP | MB_OK, 0);
}

BOOL CALLBACK InfoDlgProc(HWND hDlg,UINT iMessage,WPARAM wParam,LPARAM lParam)
{

	RECT wrt, crt;

	switch(iMessage) {
	case WM_INITDIALOG:
		if(GetWindowRect(GetParent(hDlg), &wrt) == 0){
			wrt.top = 0;
			wrt.bottom = 768;
			wrt.left = 0;
			wrt.right = 1024;         // if failed : set to 1024*768
		}			
        GetWindowRect(hDlg,&crt);			// from http://www.winapi.co.kr
		SetWindowPos(hDlg,HWND_TOPMOST,wrt.left+(wrt.right-wrt.left)/2-(crt.right-crt.left)/2,
			wrt.top+(wrt.bottom-wrt.top)/2-(crt.bottom-crt.top)/2,0,0,SWP_NOSIZE);
        return TRUE; 
	case WM_COMMAND:
		switch (wParam) {
		case IDOK:
			GetDlgItemText(hDlg, IDC_EDIT1, passwd, sizeof(passwd)); 
		case IDCANCEL:
			EndDialog(hDlg,wParam);
			return TRUE;
		}
		break;
	}
	return FALSE;
}
