#ifndef _DLL_H_
#define _DLL_H_

#ifdef BUILDING_DLL
#   ifdef __GNUWIN32__  // dev-cpp
#       define DLLIMPORT(a) extern "C"  __declspec (dllexport) a __stdcall 
#   else	// MSVC?
#       define DLLIMPORT(a) extern "C"  __declspec (dllexport) a 
#   endif
#else /* Not BUILDING_DLL */
# define DLLIMPORT __declspec (dllimport) // not used.
#endif /* Not BUILDING_DLL */

struct t_AlzData {
	t_AlzData() { curLen=0; };
	CUnAlz Data;
	struct FNode* FileList;
	tChangeVolProc ChangeVolProc;
	tProcessDataProc ProcessDataProc;

	INT64 curLen;
};   

typedef t_AlzData* UNALZHANDLE;

extern "C" BOOL APIENTRY	DllMain (HINSTANCE hInst, DWORD reason, LPVOID reserved);

static void				myAlert(const char * msg);
static void				UnAlzCallback (const char* szMessage, INT64 nCurrent, INT64 nRange, void* param, BOOL* bHalt);
static int				process_archive (t_AlzData *archivinfo, char *path, char *dest);
BOOL CALLBACK			InfoDlgProc(HWND hDlg,UINT iMessage,WPARAM wParam,LPARAM lParam);

DLLIMPORT(UNALZHANDLE)	OpenArchive (tOpenArchiveData *ArchiveData);
DLLIMPORT(int)			ReadHeader (UNALZHANDLE hArcData, tHeaderData *HeaderData);
DLLIMPORT(int)			ProcessFile (UNALZHANDLE hArcData, int Operation, char *DestPath, char *DestName);
DLLIMPORT(int)			CloseArchive (UNALZHANDLE hArcData);
DLLIMPORT(void)			SetChangeVolProc (UNALZHANDLE hArcData, tChangeVolProc pChangeVolProc);
DLLIMPORT(void)			SetProcessDataProc (UNALZHANDLE hArcData, tProcessDataProc pProcessDataProc);

#endif /* _DLL_H_ */
